diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java
index a04df889e..ffb05a58e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java
@@ -5,19 +5,19 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockRail;
+import net.minecraft.core.block.BlockLogicRail;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockModelRail<T extends BlockRail> extends BlockModelStandard<T> {
+public class BlockModelRail<T extends BlockLogicRail> extends BlockModelStandard<T> {
     protected IconCoordinate railCurve = TextureRegistry.getTexture("minecraft:block/rail/turn");
     protected IconCoordinate powerActive = TextureRegistry.getTexture("minecraft:block/rail_powered/active");
     protected IconCoordinate powerActiveOverlay = TextureRegistry.getTexture("minecraft:block/rail_powered/active_overlay");
     protected IconCoordinate detectorActiveOverlay = TextureRegistry.getTexture("minecraft:block/rail_detector/active_overlay");
 
-    public BlockModelRail(Block block) {
+    public BlockModelRail(Block<T> block) {
         super(block);
         this.hasOverbright = true;
     }
@@ -30,7 +30,7 @@ public class BlockModelRail<T extends BlockRail> extends BlockModelStandard<T> {
         {
             i1 = renderBlocks.overrideBlockTexture;
         }
-        if(block.getIsPowered())
+        if(block.getLogic().getIsPowered())
         {
             l &= 7;
         }
@@ -118,7 +118,7 @@ public class BlockModelRail<T extends BlockRail> extends BlockModelStandard<T> {
     @Override
     public IconCoordinate getBlockOverbrightTexture(WorldSource blockAccess, int x, int y, int z, int side)
     {
-        if (!block.isPowered || (blockAccess.getBlockMetadata(x, y, z) & 8) == 0) return null;
+        if (!block.getLogic().isPowered || (blockAccess.getBlockMetadata(x, y, z) & 8) == 0) return null;
 
         return block == Blocks.RAIL_POWERED ? powerActiveOverlay : detectorActiveOverlay;
     }
@@ -129,7 +129,7 @@ public class BlockModelRail<T extends BlockRail> extends BlockModelStandard<T> {
         if(block == Blocks.RAIL_POWERED && (data & 8) != 0)
         {
             return powerActive;
-        } else if(!block.isPowered && data >= 6)
+        } else if(!block.getLogic().isPowered && data >= 6)
         {
             return railCurve;
         }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRepeater.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRepeater.java
index 68e9b1fc2..debb189ba 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRepeater.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRepeater.java
@@ -4,17 +4,16 @@ import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockRepeater;
+import net.minecraft.core.block.BlockLogicRepeater;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 
-@SuppressWarnings("unchecked")
-public class BlockModelRepeater extends BlockModelStandard<BlockRepeater> {
-	private static final BlockModelTorch<Block> modelTorchActive = (BlockModelTorch<Block>) BlockModelDispatcher.getInstance().getDispatch(Blocks.TORCH_REDSTONE_ACTIVE);
-    private static final BlockModelTorch<Block> modelTorchIdle = (BlockModelTorch<Block>) BlockModelDispatcher.getInstance().getDispatch(Blocks.TORCH_REDSTONE_IDLE);
+public class BlockModelRepeater extends BlockModelStandard<BlockLogicRepeater> {
+	private static final BlockModelTorch<?> modelTorchActive = (BlockModelTorch<?>) BlockModelDispatcher.getInstance().getDispatch(Blocks.TORCH_REDSTONE_ACTIVE);
+    private static final BlockModelTorch<?> modelTorchIdle = (BlockModelTorch<?>) BlockModelDispatcher.getInstance().getDispatch(Blocks.TORCH_REDSTONE_IDLE);
 
-    public BlockModelRepeater(Block block) {
+    public BlockModelRepeater(Block<BlockLogicRepeater> block) {
         super(block);
     }
 
@@ -47,13 +46,13 @@ public class BlockModelRepeater extends BlockModelStandard<BlockRepeater> {
         float brightness = 1.0f;
         if(LightmapHelper.isLightmapEnabled()) {
         	int lmc = block.getLightmapCoord(renderBlocks.blockAccess, x, y, z);
-        	if(Blocks.lightEmission[block.id] > 0) {
+        	if(block.emission > 0) {
         		lmc = LightmapHelper.setBlocklightValue(lmc, 15);
         	}
         	tessellator.setLightmapCoord(lmc);
         }else {
     		brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
-    		if(Blocks.lightEmission[block.id] > 0 || Global.accessor.isFullbrightEnabled()) {
+    		if(block.emission > 0 || Global.accessor.isFullbrightEnabled()) {
     			brightness = 1.0f;
     		}
         }
@@ -67,26 +66,26 @@ public class BlockModelRepeater extends BlockModelStandard<BlockRepeater> {
         {
             case 0: // '\0'
                 d4 = -0.3125D;
-                d2 = BlockRepeater.torchPosOffset[j1];
+                d2 = BlockLogicRepeater.torchPosOffset[j1];
                 break;
 
             case 2: // '\002'
                 d4 = 0.3125D;
-                d2 = -BlockRepeater.torchPosOffset[j1];
+                d2 = -BlockLogicRepeater.torchPosOffset[j1];
                 break;
 
             case 3: // '\003'
                 d3 = -0.3125D;
-                d1 = BlockRepeater.torchPosOffset[j1];
+                d1 = BlockLogicRepeater.torchPosOffset[j1];
                 break;
 
             case 1: // '\001'
                 d3 = 0.3125D;
-                d1 = -BlockRepeater.torchPosOffset[j1];
+                d1 = -BlockLogicRepeater.torchPosOffset[j1];
                 break;
         }
-        BlockModelTorch<Block> modelTorch = block.isRepeaterPowered ? modelTorchActive : modelTorchIdle;
-        if (renderBlocks.overbright && block.isRepeaterPowered) {
+        BlockModelTorch<?> modelTorch = block.getLogic().isRepeaterPowered ? modelTorchActive : modelTorchIdle;
+        if (renderBlocks.overbright && block.getLogic().isRepeaterPowered) {
             modelTorch.renderTorchAtAngle(tessellator, (double)x + d1, (double)y + d, (double)z + d2, 0.0D, 0.0D);
             modelTorch.renderTorchAtAngle(tessellator, (double)x + d3, (double)y + d, (double)z + d4, 0.0D, 0.0D);
         } else if (!renderBlocks.overbright) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java
index b25050257..5317450e0 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java
@@ -2,23 +2,24 @@ package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockLanternFirefly;
-import net.minecraft.core.block.BlockRope;
+import net.minecraft.core.block.BlockLogicLanternFirefly;
+import net.minecraft.core.block.BlockLogicRope;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockModelRope<T extends BlockRope>
+public class BlockModelRope<T extends BlockLogicRope>
 extends BlockModelStandard<T> {
-    public BlockModelRope(Block block) {
+    public BlockModelRope(Block<T> block) {
         super(block);
     }
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
         WorldSource world = renderBlocks.blockAccess;
-        boolean hasFloor = world.getBlock(x, y - 1, z) != null && world.getBlock(x, y - 1, z).canPlaceOnSurface();
+        Block<?> below;
+        boolean hasFloor = (below = world.getBlock(x, y - 1, z)) != null && below.canPlaceOnSurface();
         boolean hasBlockNegX = canConnect(world, x, y, z, Side.WEST);
         boolean hasBlockPosX = canConnect(world, x, y, z, Side.EAST);
         boolean hasBlockNegY = canConnect(world, x, y, z, Side.BOTTOM) || hasFloor;
@@ -86,9 +87,9 @@ extends BlockModelStandard<T> {
         int blockX = x + side.getOffsetX();
         int blockY = y + side.getOffsetY();
         int blockZ = z + side.getOffsetZ();
-        Block _block = worldSource.getBlock(blockX, blockY, blockZ);
+        Block<?> _block = worldSource.getBlock(blockX, blockY, blockZ);
         if (side == Side.BOTTOM){
-            if (_block instanceof BlockLanternFirefly && (worldSource.getBlockMetadata(blockX, blockY, blockZ) & 0b1) != 0){
+            if (Block.hasLogicClass(_block, BlockLogicLanternFirefly.class) && (worldSource.getBlockMetadata(blockX, blockY, blockZ) & 0b1) != 0){
                 return true;
             }
         } else if (side == Side.TOP) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRotatable.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRotatable.java
index 67296701c..53d1eb180 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRotatable.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRotatable.java
@@ -2,11 +2,12 @@ package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.helper.Sides;
 
-public class BlockModelRotatable<T extends Block> extends BlockModelStandard<T> {
-    public BlockModelRotatable(Block block) {
+public class BlockModelRotatable<T extends BlockLogic> extends BlockModelStandard<T> {
+    public BlockModelRotatable(Block<T> block) {
         super(block);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSeat.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSeat.java
index 90b615dcb..de48d025c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSeat.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSeat.java
@@ -2,11 +2,12 @@ package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 
-public class BlockModelSeat<T extends Block> extends BlockModelStandard<T> {
-    public BlockModelSeat(Block block) {
+public class BlockModelSeat<T extends BlockLogic> extends BlockModelStandard<T> {
+    public BlockModelSeat(Block<T> block) {
         super(block);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlab.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlab.java
index f46d77c54..6ec38e54c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlab.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlab.java
@@ -2,30 +2,30 @@ package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockSlab;
+import net.minecraft.core.block.BlockLogicSlab;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockModelSlab<T extends BlockSlab> extends BlockModelStandard<T> {
-    public BlockModelSlab(Block block){
+public class BlockModelSlab<T extends BlockLogicSlab> extends BlockModelStandard<T> {
+    public BlockModelSlab(Block<T> block){
         super(block);
-        this.atlasIndices = ((BlockModelStandard<?>)BlockModelDispatcher.getInstance().getDispatch(this.block.modelBlock)).atlasIndices;
+        this.atlasIndices = ((BlockModelStandard<?>)BlockModelDispatcher.getInstance().getDispatch(this.block.getLogic().modelBlock)).atlasIndices;
         withCustomItemBounds(0, 0, 0, 1, 0.5d, 1);
     }
     @Override
     public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
-        return BlockModelDispatcher.getInstance().getDispatch(block.modelBlock).getBlockTextureFromSideAndMetadata(side, block.modelBlockMetadata);
+        return BlockModelDispatcher.getInstance().getDispatch(block.getLogic().modelBlock).getBlockTextureFromSideAndMetadata(side, block.getLogic().modelBlockMetadata);
     }
 
     @Override
     public IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side)
     {
-        return BlockModelDispatcher.getInstance().getDispatch(block.modelBlock).getBlockTextureFromSideAndMetadata(side, block.modelBlockMetadata);
+        return BlockModelDispatcher.getInstance().getDispatch(block.getLogic().modelBlock).getBlockTextureFromSideAndMetadata(side, block.getLogic().modelBlockMetadata);
     }
 
     @Override
     public int renderLayer() {
-        return BlockModelDispatcher.getInstance().getDispatch(block.modelBlock).renderLayer();
+        return BlockModelDispatcher.getInstance().getDispatch(block.getLogic().modelBlock).renderLayer();
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlabMarble.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlabMarble.java
index 5246af227..84aca82a7 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlabMarble.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlabMarble.java
@@ -3,14 +3,14 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockSlab;
+import net.minecraft.core.block.BlockLogicSlab;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockModelSlabMarble<T extends BlockSlab> extends BlockModelSlab<T> {
+public class BlockModelSlabMarble<T extends BlockLogicSlab> extends BlockModelSlab<T> {
     protected IconCoordinate slabSide = TextureRegistry.getTexture("minecraft:block/carved_marble");
-    public BlockModelSlabMarble(Block block) {
+    public BlockModelSlabMarble(Block<T> block) {
         super(block);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlabPainted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlabPainted.java
index bd3130f6a..8d3bd72f1 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlabPainted.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlabPainted.java
@@ -2,12 +2,12 @@ package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockSlab;
+import net.minecraft.core.block.BlockLogicSlab;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockModelSlabPainted<T extends BlockSlab> extends BlockModelSlab<T> {
-    public BlockModelSlabPainted(Block block) {
+public class BlockModelSlabPainted<T extends BlockLogicSlab> extends BlockModelSlab<T> {
+    public BlockModelSlabPainted(Block<T> block) {
         super(block);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSpikes.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSpikes.java
index 4306355f8..44397d205 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSpikes.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSpikes.java
@@ -4,12 +4,13 @@ import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockSpikes;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicSpikes;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 
-public class BlockModelSpikes<T extends Block> extends BlockModelStandard<T> {
-    public BlockModelSpikes(Block block) {
+public class BlockModelSpikes<T extends BlockLogic> extends BlockModelStandard<T> {
+    public BlockModelSpikes(Block<T> block) {
         super(block);
     }
 
@@ -24,7 +25,7 @@ public class BlockModelSpikes<T extends Block> extends BlockModelStandard<T> {
 
         renderStandardBlock(tessellator, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 0.1875F, 1.0F), x, y, z);
 
-        if(BlockSpikes.isSpikesUp(metaData)) {
+        if(BlockLogicSpikes.isSpikesUp(metaData)) {
             float brightness = 1.0f;
             if(LightmapHelper.isLightmapEnabled()) {
             	tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z));
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java
index 568febe01..1ba715e77 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java
@@ -4,17 +4,17 @@ import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockStairs;
+import net.minecraft.core.block.BlockLogicStairs;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
-public class BlockModelStairs<T extends BlockStairs> extends BlockModelStandard<T> {
-    public BlockModelStairs(Block block) {
+public class BlockModelStairs<T extends BlockLogicStairs> extends BlockModelStandard<T> {
+    public BlockModelStairs(Block<T> block) {
         super(block);
-        this.atlasIndices = ((BlockModelStandard<?>)BlockModelDispatcher.getInstance().getDispatch(this.block.modelBlock)).atlasIndices;
+        this.atlasIndices = ((BlockModelStandard<?>)BlockModelDispatcher.getInstance().getDispatch(this.block.getLogic().modelBlock)).atlasIndices;
     }
 
     @Override
@@ -112,17 +112,17 @@ public class BlockModelStairs<T extends BlockStairs> extends BlockModelStandard<
     @Override
     public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
-        return BlockModelDispatcher.getInstance().getDispatch(block.modelBlock).getBlockTextureFromSideAndMetadata(side, data);
+        return BlockModelDispatcher.getInstance().getDispatch(block.getLogic().modelBlock).getBlockTextureFromSideAndMetadata(side, data);
     }
 
     @Override
     public IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side)
     {
-        return BlockModelDispatcher.getInstance().getDispatch(block.modelBlock).getBlockTexture(blockAccess, x, y, z, side);
+        return BlockModelDispatcher.getInstance().getDispatch(block.getLogic().modelBlock).getBlockTexture(blockAccess, x, y, z, side);
     }
 
     @Override
     public int renderLayer() {
-        return BlockModelDispatcher.getInstance().getDispatch(block.modelBlock).renderLayer();
+        return BlockModelDispatcher.getInstance().getDispatch(block.getLogic().modelBlock).renderLayer();
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairsPainted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairsPainted.java
index df02328aa..c60850ab1 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairsPainted.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairsPainted.java
@@ -2,12 +2,12 @@ package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockStairs;
+import net.minecraft.core.block.BlockLogicStairs;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockModelStairsPainted<T extends BlockStairs> extends BlockModelStairs<T> {
-    public BlockModelStairsPainted(Block block) {
+public class BlockModelStairsPainted<T extends BlockLogicStairs> extends BlockModelStairs<T> {
+    public BlockModelStairsPainted(Block<T> block) {
         super(block);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
index 8443494dd..cefbbe29b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
@@ -6,13 +6,14 @@ import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
-public class BlockModelStandard<T extends Block> extends BlockModel<T>{
+public class BlockModelStandard<T extends BlockLogic> extends BlockModel<T>{
     public static final IconCoordinate BLOCK_TEXTURE_MISSING = TextureRegistry.getTexture("minecraft:block/texture_missing");
     public static final IconCoordinate BLOCK_TEXTURE_UNASSIGNED = TextureRegistry.getTexture("minecraft:block/texture_unassigned");
     public IconCoordinate[] atlasIndices = new IconCoordinate[]{BLOCK_TEXTURE_UNASSIGNED, BLOCK_TEXTURE_UNASSIGNED, BLOCK_TEXTURE_UNASSIGNED, BLOCK_TEXTURE_UNASSIGNED, BLOCK_TEXTURE_UNASSIGNED, BLOCK_TEXTURE_UNASSIGNED};
@@ -20,7 +21,7 @@ public class BlockModelStandard<T extends Block> extends BlockModel<T>{
     public IconCoordinate overbrightTexture = null;
     public int renderlayer = 0;
 
-    public BlockModelStandard(Block block) {
+    public BlockModelStandard(Block<T> block) {
         super(block);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStoneMossy.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStoneMossy.java
index 8da732220..a32e26629 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStoneMossy.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStoneMossy.java
@@ -5,13 +5,14 @@ import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.phys.AABB;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
-public class BlockModelStoneMossy<T extends Block> extends BlockModelStandard<T> {
+public class BlockModelStoneMossy<T extends BlockLogic> extends BlockModelStandard<T> {
     protected IconCoordinate mossOverlay;
-    public BlockModelStoneMossy(Block block) {
+    public BlockModelStoneMossy(Block<T> block) {
         super(block);
         mossOverlay = TextureRegistry.getTexture("minecraft:block/moss_overlay");
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTorch.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTorch.java
index 94063164c..bb8fae801 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTorch.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTorch.java
@@ -4,12 +4,12 @@ import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockTorch;
-import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicTorch;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelTorch<T extends Block> extends BlockModelStandard<T> {
-    public BlockModelTorch(Block block) {
+public class BlockModelTorch<T extends BlockLogic> extends BlockModelStandard<T> {
+    public BlockModelTorch(Block<T> block) {
         super(block);
     }
 
@@ -20,7 +20,7 @@ public class BlockModelTorch<T extends Block> extends BlockModelStandard<T> {
             tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z));
         }else {
             brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
-            if(Blocks.lightEmission[block.id] > 0) {
+            if(block.emission > 0) {
                 brightness = 1.0F;
             }
         }
@@ -28,18 +28,18 @@ public class BlockModelTorch<T extends Block> extends BlockModelStandard<T> {
         double d = 0.4;
         double d1 = 0.5D - d;
         double d2 = 0.2;
-        int direction = renderBlocks.blockAccess.getBlockMetadata(x, y, z) & BlockTorch.MASK_DIRECTION;
+        int direction = renderBlocks.blockAccess.getBlockMetadata(x, y, z) & BlockLogicTorch.MASK_DIRECTION;
         switch (direction) {
-            case BlockTorch.SIDE_WEST:
+            case BlockLogicTorch.SIDE_WEST:
                 renderTorchAtAngle(tessellator, (double) x - d1, (double) y + d2, z, -d, 0.0D);
                 break;
-            case BlockTorch.SIDE_EAST:
+            case BlockLogicTorch.SIDE_EAST:
                 renderTorchAtAngle(tessellator, (double) x + d1, (double) y + d2, z, d, 0.0D);
                 break;
-            case BlockTorch.SIDE_NORTH:
+            case BlockLogicTorch.SIDE_NORTH:
                 renderTorchAtAngle(tessellator, x, (double) y + d2, (double) z - d1, 0.0D, -d);
                 break;
-            case BlockTorch.SIDE_SOUTH:
+            case BlockLogicTorch.SIDE_SOUTH:
                 renderTorchAtAngle(tessellator, x, (double) y + d2, (double) z + d1, 0.0D, d);
                 break;
             default:
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTorchRedstone.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTorchRedstone.java
index cae4c94ba..c79309466 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTorchRedstone.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTorchRedstone.java
@@ -2,14 +2,14 @@ package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.BlockTorchRedstone;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelTorchRedstone extends BlockModelTorch<BlockTorchRedstone> {
-    private static final BlockModel<Block> redstoneWire = BlockModelDispatcher.getInstance().getDispatch(Blocks.WIRE_REDSTONE);
+public class BlockModelTorchRedstone<T extends BlockLogic> extends BlockModelTorch<T> {
+    private static final BlockModel<?> redstoneWire = BlockModelDispatcher.getInstance().getDispatch(Blocks.WIRE_REDSTONE);
 
-    public BlockModelTorchRedstone(Block block) {
+    public BlockModelTorchRedstone(Block<T> block) {
         super(block);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTransparent.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTransparent.java
index d3bb1c846..887066417 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTransparent.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTransparent.java
@@ -1,19 +1,20 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockModelTransparent<T extends Block> extends BlockModelStandard<T> {
+public class BlockModelTransparent<T extends BlockLogic> extends BlockModelStandard<T> {
     private final boolean renderInside;
-    public BlockModelTransparent(Block block, boolean renderInside){
+    public BlockModelTransparent(Block<T> block, boolean renderInside){
         super(block);
         this.renderInside = renderInside;
     }
     @Override
     public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, int side)
     {
-        if(!renderInside && blockAccess.getBlockId(x, y, z) == block.id)
+        if(!renderInside && blockAccess.getBlockId(x, y, z) == block.id())
         {
             return false;
         } else
